<template>
  <div id="summary" class="trunk summary">
    <div class="serie_intro">
      <h2 class="text--md--home heading heading--lg text--primary text--bold">
        {{ $t('serie.summary') }}
      </h2>
      <p class="text--md text--primary">
        <span v-html="truncateDesc"></span>
        <a
          v-if="isTruncated"
          class="text--md text--primary read-more"
          @click="isTruncated = false"
        >
          {{ $t('catalog.read_more') }}
        </a>
      </p>
    </div>
    <div class="serie-info">
      <div class="serie-info-ctn">
        <p class="heading heading--md text--bold">{{ $t('serie.gender') }}</p>

        <a :href="getGenreUrl()">{{ serie.genre.name }}</a>
      </div>
      <div v-if="serie.authors" class="serie-info-ctn">
        <p class="heading heading--md text--bold">
          {{ $tc('serie.authors', serie.authors.length) }}
        </p>
        <div class="authors">
          <a
            v-for="(author, index) in serie.authors"
            :key="`author-${index}`"
            :href="getAuthorUrl(author)"
          >
            {{ author.name }}{{ serie.authors[index + 1] && '&nbsp;|&nbsp;' }}
          </a>
        </div>
      </div>
      <div v-if="serie.publishers" class="serie-info-ctn">
        <p class="heading heading--md text--bold">
          {{ $t('serie.publisher') }}
        </p>

        <a
          v-for="(pub, index) of serie.publishers"
          :key="`publisher-${index}`"
          :href="getPublisherUrl(pub)"
        >
          {{ pub.name }} {{ serie.publishers[index + 1] && '|' }}
        </a>
      </div>
      <div class="serie-info-ctn">
        <p class="heading heading--md text--bold">{{ $t('serie.public') }}</p>
        <ul>
          <li>
            <a :href="`${host}/${this.$i18n.locale}/target/${serie.target.id}`">
              {{ serie.target.name }}
            </a>
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    serie: {
      type: Object,
      required: true
    },
    isSubscription: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      isTruncated: false
    }
  },
  computed: {
    targetUrl() {
      return `/${this.$i18n.locale}/target/${this.serie.target.id}`
    },
    truncatedSynopsis() {
      return this.$utils.cutByWords(this.serie.synopsis, 400)
    },
    truncateDesc() {
      let text = this.serie.synopsis
      if (this.isTruncated) text = this.truncatedSynopsis

      return text
    },
    host() {
      return this.$config.izneoUrl
    }
  },
  mounted() {
    this.isTruncated = this.serie.synopsis !== this.truncatedSynopsis
  },
  methods: {
    getGenreUrl() {
      return `${this.host}/${this.$i18n.locale}/${
        this.isSubscription ? 'abo/' : ''
      }${this.serie.shelf.slug}/${this.serie.genre.slug}`
    },
    getAuthorUrl(author) {
      return `${this.host}/${this.$i18n.locale}/${
        this.isSubscription ? 'abo/' : ''
      }${this.$utils.getAuthorForLang(this.$i18n.locale)}/${author.slug}-${
        author.id
      }`
    },
    getPublisherUrl(publisher) {
      return `${this.host}/${this.$i18n.locale}/${
        this.isSubscription ? 'abo/' : ''
      }${this.$utils.getPublisherForLang(this.$i18n.locale)}/${
        publisher.slug
      }-${publisher.id}`
    }
  }
}
</script>

<style lang="scss" scoped>
.summary {
  padding-top: 2rem;

  .read-more {
    cursor: pointer;
    text-decoration: underline;

    &:hover {
      color: $color-secondary;
    }
  }

  @media (max-width: 768px) {
    padding-top: 0;
    padding-right: 0;
    padding-left: 0;

    .serie_intro {
      text-align: left;
    }
  }

  .serie-info {
    margin: 2rem 0;
    margin-top: 3rem;

    .serie-info-ctn {
      margin-bottom: 1rem;
      display: flex;

      .authors {
        display: flex;
        flex-wrap: wrap;

        a {
          padding: 2px 0;
        }
      }

      .heading {
        min-width: 5.5rem;
        text-align: left;
        color: #3e3e3e;
      }

      a {
        color: #808080;
        font-size: 14px;
      }
    }
  }
}
</style>
